//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

$TrustLevel::PortalUse = 1; 		//Trust for using other people's portals
$TrustLevel::PortalMakeUnder = 2;	//Trust for placing portals under people
$TrustLevel::PortalMakeBrick = 1; 	//Trust for placing portals on people's bricks

$TrustLevel::PortalMiniUse = 0; 	//Trust for using other people's portals
$TrustLevel::PortalMiniMakeUnder = 2;	//Trust for placing portals under people
$TrustLevel::PortalMiniMakeBrick = 0; 	//Trust for placing portals on people's bricks

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
   if(!$RTB::RTBR_ServerControl_Hook)
      exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
   RTB_registerPref("Portal Crush","Portal Gun","PortalGun::CrushEnabled","bool","Weapon_PortalGun",1,0,0);
}
else
{
   $PortalGun::CrushEnabled = 1;
}

//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

if(!$AddedPortalCtrl)
{
 $SpaceMods::SpaceTick::Controllers = $SpaceMods::SpaceTick::Controllers TAB "PortalGunCtrl";
 $AddedPortalCtrl = 1;
}
if(!isObject(PortalGunCtrl))
{
 new SimSet(PortalGunCtrl){callFn = "PortalGunCtrlTick";};
}

//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

datablock AudioDescription(AudioCloseQuiet3d : AudioClose3d)
{
   volume = 0.75;
};

datablock AudioProfile(PgunUseSound)
{
   filename    = "./portalgun_powerup1.wav";
   description = AudioCloseQuiet3d ;
   preload = true;
};

datablock AudioProfile(PgunFireSound)
{
   filename    = "./portalgun_shoot_red1.wav";
   description = AudioClose3d ;
   preload = true;
};

datablock AudioProfile(PgunInvalidSound)
{
   filename    = "./portal_invalid_surface3.wav";
   description = AudioClose3d ;
   preload = true;
};

datablock AudioProfile(PgunOpenSound)
{
   filename    = "./portal_open3.wav";
   description = AudioCloseQuiet3d ;
   preload = true;
};

datablock AudioProfile(PgunCloseSound)
{
   filename    = "./portal_close2.wav";
   description = AudioCloseQuiet3d ;
   preload = true;
};

//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

deathProjectile.noportal = 1;
spawnProjectile.noportal = 1;
brickDeployProjectile.noportal = 1;

//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

datablock ParticleData(pGunBlueMuzzleParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 1;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/thinRing";
	spinSpeed		= 0.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "0 0.5 0.9 0.4";
	colors[1]     = "0.0 0 0.9 0.0";
	colors[2]     = "0.0 0 0.9 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.5;
	sizes[2]      = 0;
	times[0]      = 0;
	times[1]      = 1;
	times[2]      = 1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(pGunBlueMuzzleEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.1;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "pGunBlueMuzzleParticle";
   
   useEmitterColors = 0;
   uiName = "Portal Gun Blue";
};

datablock ParticleData(pGunOrangeMuzzleParticle : pGunBlueMuzzleParticle)
{
	colors[0]     = "1 0.25 0 0.4";
	colors[1]     = "1 0 0 0.0";
};

datablock ParticleEmitterData(pGunOrangeMuzzleEmitter : pGunBlueMuzzleEmitter)
{
   particles = "pGunOrangeMuzzleParticle";
   uiName = "Portal Gun Orange";
};

datablock ItemData(PGunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./l-portalgun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Portal Gun";
	iconName = "./Icon_pGun";
	doColorShift = false;
	colorShiftColor = "1 1 1 1";

	 // Dynamic properties defined by the scripts
	image = PGunBlueImage;
	canDrop = true;
};

AddDamageType("PortalCrush",   '<bitmap:Add-Ons/Weapon_PortalGun/crush> %1',    '%2 <bitmap:Add-Ons/Weapon_PortalGun/crush> %1',0.2,1);
datablock ProjectileData(portalProjectileBlue)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 0;
   directDamageType    = $DamageType::PortalCrush;
   radiusDamageType    = $DamageType::PortalCrush;

   brickExplosionRadius = 0;
   brickExplosionImpact = false;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 0;
   verticalImpulse	  = 0;
   explosion           = "";
   particleEmitter     = pGunBlueMuzzleEmitter; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 4000;
   bounceElasticity    = 0;
   bounceFriction      = 1;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   noPortal = 1;
   noProjectileHit = 1;

   uiName = "Portal (Blue)";
};

datablock ShapeBaseImageData(PGunBlueImage)
{
   shapeFile = "./l-portalgun.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0"; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   isGravGun = 1;
   gravFunc = "altPortalFire";

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = PGunItem;
   ammo = " ";
   projectile = portalProjectileBlue;
   projectileType = Projectile;

   casing = "";
   shellExitDir        = "1.0 -1.3 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 15.0;	
   shellVelocity       = 7.0;

   melee = false;
   armReady = true;

   doColorShift = true;
   colorShiftColor = "0 0 1 1.000";


	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= "";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateEmitter[1]					= pGunBlueMuzzleEmitter;
	stateEmitterTime[1]				= 10000;
	stateEmitterNode[1]				= "muzzlePoint";
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= pGunBlueMuzzleEmitter;
	stateEmitterTime[2]				= 0.5;
	stateEmitterNode[2]				= "muzzlePoint";
	stateSound[2]					= "";
	stateEjectShell[2]       = false;

	stateName[3]			= "Reload";
	stateScript[3] = "onReload";
	stateSequence[3]                = "Reload";
	stateTransitionOnTriggerUp[3]     = "Ready";
	stateSequence[3]	= "Ready";
	stateEmitter[3] = "";
	stateEmitterTime[3]				= 0.01;

};

datablock ProjectileData(portalProjectileOrange : portalProjectileBlue)
{
   uiName = "Portal (Orange)";
   particleEmitter     = pGunOrangeMuzzleEmitter;
   noPortal = 1;
};

datablock ShapeBaseImageData(PGunOrangeImage : PGunBlueImage)
{
   projectile = portalProjectileOrange;
   colorShiftColor = "1 0.25 0 1.000";
   stateSound[0]					= "";
   stateEmitter[1]					= pGunOrangeMuzzleEmitter;
   stateEmitter[2]					= pGunOrangeMuzzleEmitter;
};

if(!isObject(grGunParticle))
{
 datablock ParticleData(grGunParticle : printGunParticle)
 {
 	colors[0]     = "0.9 0.2 0.0 0.9";
	colors[1]     = "0.9 0.2 0.0 0.0";
 };

 datablock ParticleData(grGunParticle2 : grGunParticle)
 {
 	colors[0]     = "0.9 0.2 0.0 0.9";
	colors[1]     = "0.9 0.2 0.0 0.0";
	sizes[0]      = 0.1;
	sizes[1]      = 0.1;
              dragCoefficient = 0;
	lifetimeMS           = 500;
 };

 datablock ParticleEmitterData(grGunEmitter : printGunEmitter)
 {
  particles = grGunParticle;
 };

 datablock ParticleEmitterData(grGunEmitter2 : printGunEmitter)
 {
  particles = grGunParticle2;
 };

 datablock ParticleEmitterData(grGunExplosionEmitter)
 {
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 1.0;
  velocityVariance = 1.0;
  ejectionOffset   = 0.0;
  thetaMin         = 0;
  thetaMax         = 90;
  phiReferenceVel  = 0;
  phiVariance      = 360;
  overrideAdvance = false;
  particles = grGunParticle2;
 };

 datablock ExplosionData(grGunExplosion)
 {
   //explosionShape = "";
   //soundProfile = "";

   lifeTimeMS = 3;

   particleEmitter = grGunExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = "";

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0 0 0";
   lightEndColor = "0 0 0";
 };

 datablock ExplosionData(grGunExplosion2 : grGunExplosion)
 {
   impulseRadius = 2;
   impulseForce = 8000;
 };
}

datablock ProjectileData(PGunPickupProjectile)
{
  muzzleVelocity      = 100;
  fadeDelay           = 3500;
  lifetime            = 100;
  explosion = grGunExplosion;
  particleEmitter = "";
  impactImpulse	   = 0;
  verticalImpulse	   = 0;
  noPortal = 1;
  noProjectileHit = 1;
};

datablock ShapeBaseImageData(PGunPickupImage : printGunImage)
{
   colorShiftColor = "1 1 1 1";
   shapeFile = "./l-portalgun.dts";
   item = PGunItem;
   projectile = PGunPickupProjectile;
   projectileType = Projectile;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0"; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );


	// States
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= PgunUseSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateEmitter[1]					= pGunOrangeMuzzleEmitter;
	stateEmitterTime[1]				= 10000;
	stateEmitterNode[1]				= "muzzlePoint";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.2;
                   stateTransitionOnAmmo[2] = "GravLoop";
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= "grGunemitter";
	stateEmitterTime[2]				= 0.15;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= printFireSound;
	stateEjectShell[2]       = false;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateTransitionOnTrigger[3]     = "Ready";
	stateSequence[3]	= "Ready";

	stateName[4]			= "GravLoop";
	stateEmitter[4]					= grGunEmitter2;
	stateEmitterTime[4]				= 0.01;
	stateEmitterNode[4]				= "muzzleNode";
              stateTransitionOnTimeout[4]     = "GravLoop";
              stateTransitionOnTriggerUp[4] = "Cancel";
              stateTransitionOnNoAmmo[4] = "Cancel2";
              stateTimeoutValue[4]            = 0.01;
              stateScript[4]                  = "onGrav";
	stateSequence[4]	= "Ready";

              stateName[5] = "Cancel";
              stateScript[5] = "onCancel";
              stateTimeoutValue[5] = "0.1";
              stateTransitionOnTimeout[5] = "Ready";

              stateName[6] = "Cancel2";
              stateScript[6] = "onCancel";
              stateTimeoutValue[6] = "0.5";
              stateTransitionOnTimeout[6] = "Ready";
              stateTransitionOnTriggerUp[6] = "Ready";
};

datablock ParticleData(PGunBluePortalParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 10.0;
	spinRandomMin		= 0.0;
	spinRandomMax		= 0.0;
	colors[0]     = "0 1 1 0.9";
	colors[1]     = "0 0 1 1";
	colors[2]     = "0 0 1 1";
	sizes[0]      = 0.5;
	sizes[1]      = 1;
	sizes[2]      = 2;

	useInvAlpha = false;
};
datablock ParticleEmitterData(PgunBluePortalEmitter)
{
   lifeTimeMS = 3000;
   ejectionPeriodMS = 2;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 80; //0
   thetaMax         = 100; //360
   phiReferenceVel  = 0; //0
   phiVariance      = 360; //0
   overrideAdvance = false;
   particles = PgunBluePortalParticle;
};

datablock ParticleData(PGunOrangePortalParticle : PGunBluePortalParticle)
{
	colors[0]     = "0.5 0.25 0 0.9";
	colors[1]     = "0.5 0 0 0.5";
	colors[2]     = "0.5 0 0 0";
};

datablock ParticleEmitterData(PgunOrangePortalEmitter : PgunBluePortalEmitter)
{
 particles = PGunOrangePortalParticle;
};

datablock ParticleData(pGunInvalidPortalParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 0;
	textureName          = "base/data/particles/ring";
	spinSpeed		= 0.0;
	spinRandomMin		= -000.0;
	spinRandomMax		= 000.0;
	colors[0]     = "0.9 0.9 0.9";
	colors[1]     = "0.9 0.9 0.9 0.0";
	sizes[0]      = 0.1;
	sizes[1]      = 3.5;

	useInvAlpha = false;
};
datablock ParticleEmitterData(pGunInvalidPortalEmitter)
{
   ejectionPeriodMS = 100;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 00;
   phiReferenceVel  = 0;
   faceViewer = false;
   phiVariance      = 0;
   overrideAdvance = false;
   particles = "pGunInvalidPortalParticle";
};

//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function PortalGunCtrlTick(%this)
{
 for(%i=0;%i<%this.getCount();%i++)
 {
  %obj = %this.getObject(%i);

  if(!isObject(%obj.sourceObject)){%obj.delete();%i--;continue;}
  if((%obj.sourceObject.getClassName() $= "Player" || %obj.sourceObject.getClassName() $= "AIPlayer") && %obj.sourceObject.getState() $= "Dead"){%obj.delete();%i--;continue;}
  if(%obj.sourceObject.getClassName() $= "fxDTSBrick" && (%obj.sourceObject.isDead() || %obj.sourceObject.isFakeDead())){%obj.delete();%i--;continue;}
  if(!isObject(%obj.colObject)){%obj.delete();%i--;continue;}

  initContainerRadiusSearch(%obj.position,18,$TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::ProjectileObjectType);
  while(isObject(firstWord(%searchObj = containerSearchNext())))
  {
   if(%searchObj.getClassName() $= "Player" || %searchObj.getClassName() $= "AIPlayer")
   {
    %pos = %searchObj.getHackPosition();
    %r = 3;
   }
   else if(%searchObj.getClassName() !$= "Projectile")
   {
    %pos = %searchObj.getWorldBoxCenter();
    %r = 3.5;
   }
   else
   {
    if(%searchObj.getdatablock().noportal){continue;}
    %pos = %searchObj.position;
    %r = vectorLen(%searchObj.initialVelocity)/10;
    if(%r > 6){%r = 6;}
    if(%r < 3){%r = 3;}
   }
   if(vectorDist(%pos,%obj.position) < %r) //Radius searches find bounding box not actual object and mess up with players
    portalTeleport(%obj,%searchObj);
  }
 }
 for(%i=0;%i<clientgroup.getcount();%i++)
 {
  if(!isObject((%searchObj = clientgroup.getobject(%i).player))){return;}
  if(mAbs(%searchObj.portalVel - vectorLen(%searchobj.getVelocity())) > 2)
  {
   %searchobj.portalVel = vectorLen(%searchobj.getVelocity());
  }
 }
}

function servercmdclearportals(%c)
{
 if(!%c.isSuperAdmin){return;}
 if(!isObject(PortalGunCtrl.getObject(0))){return;}
 messageall('MsgClearBricks',"\c3" @ %c.name @ "\c0 cleared all \c3Portals\c0.");
 while(isObject((%obj = PortalGunCtrl.getObject(0))))
 {
  %obj.delete();
 }
}

function portalTeleport(%portal,%player)
{
 if($Sim::Time-%player.lastDetected < 0.75 && %portal $= %player.lastportal){return;}
 if(inSameMinigame(%portal.client,%player)){%level = $TrustLevel::PortalMiniUse;}else{%level = $TrustLevel::PortalUse;}
 if(%player.getClassName() $= "Player" && %portal.sourceObject.getClassName() $= "Player" && getTrustLevel(%player.client,%portal.client) < %level)
 {
    %player.lastDetected = $Sim::Time;
    %player.lastPortal = %portal;
    commandtoclient(%player.client,'centerprint',%portal.client.name @ " does not trust you enough to do that.",2,3);
    return;
 }
 
 if(%player.getClassName() $= "Player" || %player.getClassName() $= "AIPlayer")
 {
  %owner = %player;
 }
 else if(%player.getClassName() $= "Projectile")
 {
  %owner = %player.client.player;
 }
 else
 {
  if(isObject(%player.holder)){%owner = %player.holder;}
 }

 if(%portal.portalType $= "Blue")
 {
  if(!%portal.sourceObject.lockOrangePortal && isObject(%portal.sourceObject.portalOrange))
  {
   %pair = %portal.sourceObject.portalOrange;
  }
  else if(isObject(getMinigameFromObject(%portal.sourceObject)) && %portal.sourceObject.lockOrangePortal && isObject(%portal.sourceObject.linkPortal.portalOrange))
  {
   %pair = %portal.sourceObject.linkPortal.portalOrange;
  }
  else if(isObject(getMinigameFromObject(%owner.client)) && %owner.lockBluePortal && %owner.linkPortal.portalBlue == %portal && isObject(%owner.portalOrange))
  {
   %pair = %owner.portalOrange;
  }
 }
 else
 {
  if(!%portal.sourceObject.lockBluePortal && isObject(%portal.sourceObject.portalBlue))
  {
   %pair = %portal.sourceObject.portalBlue;
  }
  else if(isObject(getMinigameFromObject(%portal.sourceObject)) && %portal.sourceObject.lockBluePortal && isObject(%portal.sourceObject.linkPortal.portalBlue))
  {
   %pair = %portal.sourceObject.linkPortal.portalBlue;
  }
  else if(isObject(getMinigameFromObject(%owner.client)) && %owner.lockOrangePortal && %owner.linkPortal.portalOrange == %portal && isObject(%owner.portalBlue))
  {
   %pair = %owner.portalBlue;
  }
 }
 
 if(!isObject(%pair))
  return;

 if(%player.getClassName() $= "Projectile")
 {
  %type = %player.getDatablock();
  %v = vectorLen(%player.initialVelocity);
  %t = %player.createtime;
  %life = %type.lifetime * %type.muzzleVelocity;
  %sched = (%t - $Sim::Time + %life/1000)*1000;
  if(%sched < 0){return;}
  %p = new Projectile()
  {
			dataBlock = %type;
			initialVelocity = vectorScale(%pair.normal,vectorLen(%player.initialVelocity));
			initialPosition = vectorAdd(%pair.getTransform(),vectorScale(%pair.normal,0));
			originPoint = vectorAdd(%pair.getTransform(),vectorScale(%pair.normal,0));
			sourceObject = %player.sourceObject;
			sourceSlot = %player.sourceSlot;
			client = %player.client;
			lastDetected = $Sim::Time+(%v < 5 ? 5-%v : 0);
			lastPortal = %pair;
  };missionCleanup.add(%p);
  %p.schedule(1,setPortalCreateTime,%t);
  %p.schedule(%sched,explode);
  %p.setScale(%player.getScale());
  %player.delete();
  return;
 }

 if(%player.isHeld)
 {
  cancel(%player.gravSched);
  %player.gravSched = %player.schedule(3000,gravHold);
  %player.holder.gravObj = "";
  %player.holder = "";
  %player.isHeld = "";
  %player.disablemove = 0;
 }

 %player.lastDetected = $Sim::Time;
 %player.lastPortal = %pair;
 if(%player.isMounted()){return;}

 if(%player.getclassname() $= "Player" || %player.getclassname() $= "AIPlayer")
 {
  %add = vectorDist(%player.getPosition(),%player.getHackPosition());
 }
 else
 {
  %add = 0;
 }

 %normal = %pair.normal;
 %pos1 = vectorAdd(%pair.position,"0 0 0");
 %pos2 = vectorAdd(%pair.position,vectorScale(%pair.normal,3));
 %masks =	$typemasks::interiorobjecttype | //InteriorInstance
		$TypeMasks::StaticObjectType | //StaticShape?
		$TypeMasks::StaticShapeObjectType | //StaticShape?
		$TypeMasks::StaticTSObjectType | //TSStatics
		$typemasks::fxbrickobjecttype | //fxDTSBricks
		$TypeMasks::TerrainObjectType | //Terrain
		$TypeMasks::ShapeBaseObjectType; //Players vehicles etc
 %scanTarg = ContainerRayCast (%pos1, %pos2, %masks,%player);
 if(isObject(firstWord(%scanTarg)))
 {
  if(inSameMinigame(%owner.client,firstWord(%scanTarg)) && $PortalGun::CrushEnabled) //Portal Crush both objects if the end is blocked
  {
   %player.damage(%player, %pos2, 99999, $DamageType::PortalCrush);
   if(firstWord(%scanTarg).getClassName() !$= "fxDTSBrick") //The brick will be killed by the tank projectile only if brick damage is on
   {
    firstWord(%scanTarg).damage(%player, %pos2, 99999, $DamageType::PortalCrush);
   }
   %p = new Projectile()
   {
			dataBlock = tankShellProjectile; //This will always exist since the tank force-run
			initialVelocity = "0 0 1";
			initialPosition = %pos2;
			originPoint = %pos2;
			sourceObject = %player;
			sourceSlot = 0;
			client = (%player.getClassName() $= "Player" ? %player.client : %player.spawnbrick.client);
			sourceClient = (%player.getClassName() $= "Player" ? %player.client : %player.spawnbrick.client);
			lastDetected = $Sim::Time;
			lastPortal = %pair;
   };missionCleanup.add(%p);%p.explode();
  }
  else
  {
   %player.lastPortal = %portal;
   serverplay3d(PgunInvalidSound,%portal.position SPC "0 0 1 0");
   commandtoclient(%owner.client,'centerprint',"Portal Blocked!",1,3);
   return;
  }
 }

 if(!isObject(%player)){return;}
 %normal = %pair.normal;
 %r = rotFromTransform(%player.gettransform());
 %n = rotFromTransform(%pair.gettransform());
 %vel = vectorLen(%player.getVelocity()) > 4 ? vectorLen(%player.getVelocity()) : 4;
 %vel = (%player.portalVel > %vel ? %player.portalVel : %vel);
 %player.setVelocity(vectorScale(%pair.normal,%vel));
 %player.setTransform(vectorAdd(%pair.getTransform(),vectorScale(%pair.normal,%add+1)) SPC %r);
 %player.portalVel = "";

}

function portalProjectileBlue::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
 //Spawned normally: source=player, client=client
 //Spawned from brick: source=brick, spawnBrick=brick, client=client, sourceClient=client

 %class = %col.getClassName();

 if(%class !$= "InteriorInstance" && %class !$= "StaticShape" && %class !$= "TSStatic" && %col.getClassName() !$= "fxDTSBrick" && %class !$= "TerrainBlock")
 {
  portalError(%pos,%obj.originPoint);
  return;
 }

 if(%class $= "fxDTSBrick")
 {
  if(inSameMinigame(%obj.client,%col))
  {
   %trustBrick = $TrustLevel::PortalMiniMakeBrick;
  }
  else
  {
   %trustBrick = $TrustLevel::PortalMakeBrick;
  }
  if(getTrustLevel(%obj.client,%col.getGroup()) < %trustBrick)
  {
   portalError(%pos,%obj.originPoint);
   if(isObject(%obj.sourceObject) && %obj.sourceObject.getClassName() $= "Player")
   {
    commandtoclient(%obj.client,'centerprint',%col.getGroup().name @ " does not trust you enough to do that.",2,3);
   }
   return;
  }
  if(%col.getDatablock().noPortal || %col.antiPortal)
  {
   portalError(%pos,%obj.originPoint);
   return;
  }
 }

 for(%i=0;%i<PortalGunCtrl.getCount();%i++)
 {
  %portal = PortalGunCtrl.getObject(%i);
  if(vectorDist(%portal.position,%pos) < 5 && %portal != %obj.sourceObject.portalBlue)
  {
   portalError(%pos,%obj.originPoint);
   return;
  }
 }

 for(%i=0;%i<ClientGroup.getCount();%i++)
 {
  %client = ClientGroup.getObject(%i);
  %player = %client.player;
  if(!isObject(%client.player))
   continue;
  if(inSameMinigame(%client,%obj.client))
  {
   %trustUnder = $TrustLevel::PortalMiniMakeUnder;
  }
  else
  {
   %trustUnder = $TrustLevel::PortalMakeUnder;
  }
  if(vectorDist(%pos,%client.player.getPosition()) < 1 && getTrustLevel(%client,%obj.client) < %trustUnder)
  {
   portalError(%pos,%obj.originPoint);
   if(isObject(%obj.sourceObject) && %obj.sourceObject.getClassName() $= "Player")
   {
    commandtoclient(%obj.client,'centerprint',%client.name @ " does not trust you enough to do that.",2,3);
   }
   return;
  }
 }

 initContainerRadiusSearch(%pos,0.5,$TypeMasks::FXBrickObjectType);
 while(isObject(firstWord(%searchObj = containerSearchNext())))
 {
  if(inSameMinigame(%obj.client,%searchObj))
  {
   %trustBrick = $TrustLevel::PortalMiniMakeBrick;
  }
  else
  {
   %trustBrick = $TrustLevel::PortalMakeBrick;
  }
  if(getTrustLevel(%obj.client,%searchObj.getGroup()) < %trustBrick)
  {
   portalError(%pos,%obj.originPoint);
   if(isObject(%obj.sourceObject) && %obj.sourceObject.getClassName() $= "Player")
   {
    commandtoclient(%obj.client,'centerprint',%col.getGroup().name @ " does not trust you enough to do that.",2,3);
   }
   return;
  }
  if(%searchObj.getDatablock().noPortal || %searchObj.antiPortal)
  {
   portalError(%pos,%obj.originPoint);
   return;
  }
 }

 serverplay3d(PgunOpenSound,%pos SPC "0 0 1 0");
 if(isObject(%obj.client))
  %obj.client.play2d(PgunOpenSound);

 if(isObject(%obj.sourceObject.portalBlue)){%obj.sourceObject.portalBlue.delete();}
 %rot = -(getWord(%normal,1)) SPC -(getWord(%normal,0)) SPC getWord(%normal,2) SPC "90";
// %rot = vectorCross((getWord(%normal,1)) SPC -(getWord(%normal,0)) SPC getWord(%normal,2),"0 0 1") SPC 90;
 %p = new ParticleEmitterNode()
 {
  datablock = genericEmitterNode;
  emitter = PGunBluePortalEmitter;
  scale = "0.1 0.1 0.1";
  rotation = %rot;
  velocity = "1";
  position = vectorAdd(%pos,vectorScale(%normal,0.4));
  normal = %normal;
  client = %obj.client;
  sourceObject = %obj.sourceObject;
  colObject = %col;
  portalType = "Blue";
 };
 %obj.sourceObject.portalBlue = %p;
 PortalGunCtrl.add(%p); 
 
 Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
}

function portalProjectileOrange::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
 //Spawned normally: source=player, client=client
 //Spawned from brick: source=brick, spawnBrick=brick, client=client, sourceClient=client

 %class = %col.getClassName();

 if(%class !$= "InteriorInstance" && %class !$= "StaticShape" && %class !$= "TSStatic" && %col.getClassName() !$= "fxDTSBrick" && %class !$= "TerrainBlock")
 {
  portalError(%pos,%obj.originPoint);
  return;
 }

 if(%class $= "fxDTSBrick")
 {
  if(inSameMinigame(%obj.client,%col))
  {
   %trustBrick = $TrustLevel::PortalMiniMakeBrick;
  }
  else
  {
   %trustBrick = $TrustLevel::PortalMakeBrick;
  }
  if(getTrustLevel(%obj.client,%col.getGroup()) < %trustBrick)
  {
   portalError(%pos,%obj.originPoint);
   if(isObject(%obj.sourceObject) && %obj.sourceObject.getClassName() $= "Player")
   {
    commandtoclient(%obj.client,'centerprint',%col.getGroup().name @ " does not trust you enough to do that.",2,3);
   }
   return;
  }
  if(%col.getDatablock().noPortal || %col.antiPortal)
  {
   portalError(%pos,%obj.originPoint);
   return;
  }
 }

 for(%i=0;%i<PortalGunCtrl.getCount();%i++)
 {
  %portal = PortalGunCtrl.getObject(%i);
  if(vectorDist(%portal.position,%pos) < 5 && %portal != %obj.sourceObject.portalOrange)
  {
   portalError(%pos,%obj.originPoint);
   return;
  }
 }

 for(%i=0;%i<ClientGroup.getCount();%i++)
 {
  %client = ClientGroup.getObject(%i);
  %player = %client.player;
  if(!isObject(%client.player))
   continue;
  if(inSameMinigame(%client,%obj.client))
  {
   %trustUnder = $TrustLevel::PortalMiniMakeUnder;
  }
  else
  {
   %trustUnder = $TrustLevel::PortalMakeUnder;
  }
  if(vectorDist(%pos,%client.player.getPosition()) < 1 && getTrustLevel(%client,%obj.client) < %trustUnder)
  {
   portalError(%pos,%obj.originPoint);
   if(isObject(%obj.sourceObject) && %obj.sourceObject.getClassName() $= "Player")
   {
    commandtoclient(%obj.client,'centerprint',%client.name @ " does not trust you enough to do that.",2,3);
   }
   return;
  }
 }

 initContainerRadiusSearch(%pos,0.5,$TypeMasks::FXBrickObjectType);
 while(isObject(firstWord(%searchObj = containerSearchNext())))
 {
  if(inSameMinigame(%obj.client,%searchObj))
  {
   %trustBrick = $TrustLevel::PortalMiniMakeBrick;
  }
  else
  {
   %trustBrick = $TrustLevel::PortalMakeBrick;
  }
  if(getTrustLevel(%obj.client,%searchObj.getGroup()) < %trustBrick)
  {
   portalError(%pos,%obj.originPoint);
   if(isObject(%obj.sourceObject) && %obj.sourceObject.getClassName() $= "Player")
   {
    commandtoclient(%obj.client,'centerprint',%col.getGroup().name @ " does not trust you enough to do that.",2,3);
   }
   return;
  }
  if(%searchObj.getDatablock().noPortal || %searchObj.antiPortal)
  {
   portalError(%pos,%obj.originPoint);
   return;
  }
 }

 serverplay3d(PgunOpenSound,%pos SPC "0 0 1 0");
 if(isObject(%obj.client))
  %obj.client.play2d(PgunOpenSound);

 if(isObject(%obj.sourceObject.portalOrange)){%obj.sourceObject.portalOrange.delete();}

 %rot = -(getWord(%normal,1)) SPC -(getWord(%normal,0)) SPC getWord(%normal,2) SPC "90";
 %p = new ParticleEmitterNode()
 {
  datablock = genericEmitterNode;
  emitter = PGunOrangePortalEmitter;
  scale = "0.1 0.1 0.1";
  rotation = %rot;
  velocity = "1";
  client = %obj.client;
  position = vectorAdd(%pos,vectorScale(%normal,0.4));
  normal = %normal;
  sourceObject = %obj.sourceObject;
  colObject = %col;
  portalType = "Orange";
 };
 %obj.sourceObject.portalOrange = %p;
 PortalGunCtrl.add(%p); 
 
 Parent::onCollision(%this,%obj,%col,%fade,%pos,%normal);
}

function PGunBlueImage::onFire(%this,%obj,%slot)
{
 if(!isObject(%obj) || %obj.getState() $= "Dead"){return;}
 %obj.setImageTrigger(0,0);
 if(%obj.fireorangePortal)
 {
  %obj.fireorangePortal = 0;
  if(isObject(%obj.client.minigame) && %obj.lockorangePortal)
  {
   serverPlay3d(PgunInvalidSound,%obj.getTransform());
   return;
  }
  if(isObject(%obj.orangePortalProjectile)){%obj.orangePortalProjectile.delete();}
  %this.projectile = portalProjectileOrange;
  %obj.playThread(2, shiftAway);
  Parent::onFire(%this,%obj,%slot);
  %obj.disablePortalMountSound = 1;
  %obj.mountImage(pGunOrangeImage,0);
  serverplay3d(PgunFireSound,%obj.getHackPosition());
 }
 else
 {
  if(isObject(%obj.client.minigame) && %obj.lockBluePortal)
  {
   serverPlay3d(PgunInvalidSound,%obj.getTransform());
   return;
  }
  if(isObject(%obj.bluePortalProjectile)){%obj.bluePortalProjectile.delete();}
  %this.projectile = portalProjectileBlue;
  %obj.playThread(2, shiftAway);
  Parent::onFire(%this,%obj,%slot);
  %obj.disablePortalMountSound = 1;
  %obj.mountImage(pGunBlueImage,0);
  serverplay3d(PgunFireSound,%obj.getHackPosition());
 }
}

function PGunOrangeImage::onFire(%this,%obj,%slot)
{
 PGunBlueImage::onFire(%this,%obj,%slot);
}

function PGunBlueImage::onMount(%this,%obj,%slot)
{
 Parent::onMount(%this,%obj,%slot);
 if(%obj.lockBluePortal)
 {
  %obj.mountImage(pGunPickupImage,0);
  return;
 }
 if(%obj.disablePortalMountSound)
 {
  %obj.disablePortalMountSound = 0;
 }
 else
 {
  serverplay3d(PgunUseSound,%obj.getTransform());
 }
}

function PGunOrangeImage::onMount(%this,%obj,%slot)
{
 Parent::onMount(%this,%obj,%slot);
 if(%obj.disablePortalMountSound)
 {
  %obj.disablePortalMountSound = 0;
 }
 else
 {
  serverplay3d(PgunUseSound,%obj.getTransform());
 }
}

function altPortalFire(%this,%obj,%slot,%on)
{
 if(%obj.getImageState(0) !$= "Ready")
 {
  return;
 }
 %obj.fireOrangePortal = 1;
 %obj.setImageTrigger(0,1);
}

function portalError(%pos,%pos2)
{
 serverplay3d(PgunInvalidSound,%pos2 SPC "0 0 1 0");
 if(vectorDist(%pos,%pos2) > 5){serverplay3d(PgunInvalidSound,%pos SPC "0 0 1 0");}
 %p = new ParticleEmitterNode()
 {
  datablock = genericEmitterNode;
  emitter = "pGunInvalidPortalEmitter";
  scale = "0 0 0";
  rotation = %r;
  velocity = "1";
  position = %pos;
 };%p.brick = %p;%p.schedule(100,delete);
}

function inSameMinigame(%obj1,%obj2)
{
 if(!isObject(%obj1)){return 0;}
 if(!isObject(%obj2)){return 0;}
 if(isObject(%obj1.spawnBrick)){%obj1 = %obj1.spawnBrick;}
 if(isObject(%obj2.spawnBrick)){%obj2 = %obj2.spawnBrick;}
 if(isObject(%obj1) && %obj1.getClassName() $= "fxDTSBrick"){%obj1 = %obj1.getGroup();}
 if(isObject(%obj2) && %obj2.getClassName() $= "fxDTSBrick"){%obj2 = %obj2.getGroup();}
 return (isObject(getMinigameFromObject(%obj1)) && getMinigameFromObject(%obj1) == getMinigameFromObject(%obj2));
}

//Trader's euler/axis angle conversion functions

function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}

//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

function  pGunPickupImage::onMount(%this,%obj,%slot)
{
 %obj.setImageAmmo(0,0);
}

function pGunPickupImage::onCancel(%this,%obj,%slot)
{
 if(isObject(%obj.gravObj)){ %obj.gravObj.setVelocity(vectorScale(vectorSub(%obj.gravObj.getTransform(),%obj.gravObj.lastpos2),5));}else{return;}
 %obj.gravobj.disablemove = 0;
 %obj.gravObj.isHeld = 0;
 cancel(%obj.gravobj.gravSched);
 %obj.gravobj.gravSched = %obj.gravobj.schedule(3000,gravHold);
 %obj.gravObj = "";
 %obj.setImageAmmo(0,0);
}

function pGunPickupImage::onUnMount(%this,%obj,%slot)
{
 if(!isObject(%obj.gravObj)){return;}
 %obj.gravobj.disablemove = 0;
 cancel(%obj.gravobj.gravSched);
 %obj.gravobj.gravSched = %obj.gravobj.schedule(3000,gravHold);
 %obj.gravObj.holder = "";
 %obj.gravObj.isHeld = "";
 %obj.gravObj = "";
}

function PgunPickupProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
 if(!miniGameCanDamage(%obj,%col)){return;}
 if((strStr(strLwr(%col.getClassName()),"vehicle") !$= "-1" || %col.getclassname() $= "AIPlayer") && (!%col.isHeld) && %col.spawnbrick.getGroup().client.minigame $= %obj.client.minigame)
 {
  %obj.client.player.gravobj = %col;
  %obj.client.player.gravobj.holder = %obj.client.player;
  %obj.client.player.gravobj.lastpos = %col.position;
  %obj.client.player.gravobj.lastpos2 = %col.position;
  %obj.client.player.gravobj.lastrot = "0 0 0";
  %obj.client.player.setImageAmmo(0,1);
  %obj.client.player.gravobj.disablemove = 1;
 }
}

function pGunPickupImage::onGrav(%this,%obj,%slot)
{
 %obj.setImageTrigger(0,1);
 if(!isObject(%obj.gravobj)){%obj.setImageTrigger(0,0);%obj.setImageAmmo(0,0);return;}
 if(isMountedTo(%obj,%obj.gravObj)){%obj.setImageTrigger(0,0);%obj.setImageAmmo(0,0);return;}
   %mouseVec = %obj.getMuzzleVector(0);
   %cameraPoint = %obj.getEyePoint();
   %selectRange = %obj.gravObj.getDatablock().mass / 50;
   %mouseScaled = VectorScale(%mouseVec, %selectRange);
   %rangeEnd = VectorAdd(%cameraPoint, %mouseScaled);

   %searchMasks = $TypeMasks::VehicleObjectType | $TypeMasks::FXBrickObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType;

   %player = %obj;
	  %scanTarg = ContainerRayCast (%cameraPoint, %rangeEnd, %searchMasks,%obj.gravobj);
   if(!isObject(firstWord(%scanTarg)))
   {
    %pos = %rangeEnd;
   }
   else
   {
    %sub = vectorSub(posFromRaycast(%scanTarg),%cameraPoint);
    %nom = vectorNormalize(%sub);
    %len = vectorLen(%sub);
    %pos = vectorAdd(%cameraPoint,vectorScale(%nom,%len*0.5));
   }
   %obj.gravObj.holder = %obj;
   %obj.gravObj.isHeld = 1;
   %obj.gravObj.lastPos2 = %obj.gravObj.lastPos;
   %obj.gravObj.lastPos = %obj.gravObj.getTransform();
   %t = %obj.gravObj.getTransform();
   %rot =  eulerToMatrix(%obj.gravobj.lastrot); 
     //Uncomment the line below and comment out the one below this to use alternate control method. It "swings" more realistically but kills people very easily and you if you turn too fast.
   //%obj.gravObj.setTransform(%obj.gravObj.position SPC %rot);
   %obj.gravObj.setTransform(%pos SPC %rot);
  %obj.gravobj.lastrot = vectorAdd(%obj.gravobj.lastrot,"0 0 0.035");
  //Uncomment the line below and comment out the one below this to use alternate control method. It "swings" more realistically but kills people very easily and you if you turn too fast.
   //%obj.gravObj.setVelocity(vectorScale(vectorSub(%pos,%obj.gravObj.position),5));
   %obj.gravObj.setVelocity("0 0 0");
}

//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

package PortalPackage
{
 function servercmdcancelbrick(%client)
 {
  Parent::servercmdcancelbrick(%client);
  %obj = %client.player;
  if(isObject(%obj.portalBlue)){%obj.portalBlue.delete();%play = 1;}
  if(isObject(%obj.portalOrange)){%obj.portalOrange.delete();%play = 1;}
  if(!isObject(%obj) || !%play){return;}
  serverplay3d(pGunCloseSound,%obj.getTransform());
 }
 function servercmdLight(%client)
 {
  if(isObject(%client.player) && isObject(%client.player.getMountedImage(0)))
  {
   %name = %client.player.getMountedImage(0).getName();
   if(%name $= "pGunBlueImage" || %name $= "pGunOrangeImage")
   {
    if(%client.player.lockPortalPickup)
    {
     serverPlay3d(PgunInvalidSound,%client.player.getTransform());
     return;
    }
    %client.player.mountImage(pGunPickupImage,0);return;
   }
   else if(%name $= "pGunPickupImage")
   {
    if(%client.player.lockBluePortal)
    {
     serverPlay3d(PgunInvalidSound,%client.player.getTransform());
     return;
    }
    %client.player.mountImage(PGunBlueImage,0);return;
   }
  }
  Parent::servercmdLight(%client);
 }
 function Projectile::setPortalCreateTime(%this,%time)
 {
  %this.createTime = %time;
 }
 function Projectile::onAdd(%this,%a,%b,%c,%d)
 {
  Parent::onAdd(%this,%a,%b,%c,%d);
  %this.createTime = $Sim::Time;
  if(%this.getDatablock().getName() $= "portalProjectileBlue"){%this.sourceObject.bluePortalProjectile = %this;}
  if(%this.getDatablock().getName() $= "portalProjectileOrange"){%this.sourceObject.orangePortalProjectile = %this;}
 }
};activatePackage(PortalPackage);

//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

registerOutputEvent(fxDTSBrick, setAsPortalLink, "", 1);
function fxDTSBrick::setAsPortalLink(%brick,%client)
{
 if(isObject(%client.player))
 {
  %client.player.linkPortal = %brick;
 }
}

registerOutputEvent(fxDTSBrick, clearPortalLink, "", 1);
function fxDTSBrick::clearPortalLink(%brick,%client)
{
 if(isObject(%client.player))
 {
  %client.player.linkPortal = "";
 }
}

registerOutputEvent(Player, setPortalGun, "list All 0 PortalsOnly 1 BlueOnly 2 PickupOnly 3 Blue/Pickup 4", 1);
function Player::setPortalGun(%player,%type,%client)
{
 if(isObject(%player.client.minigame))
 {
  switch(%type)
  {
   case 0:
    %player.lockPortalPickup = 0;
    %player.lockBluePortal = 0;
    %player.lockOrangePortal = 0;
   case 1:
    %player.lockPortalPickup = 1;
    %player.lockBluePortal = 0;
    %player.lockOrangePortal = 0;
    if(isObject(%player.getMountedImage(0)) && %player.getMountedImage(0).getName() $= "pGunPickupImage")
    {
     %player.mountImage(PGunBlueImage,0);
    }
   case 2:
    %player.lockPortalPickup = 1;
    %player.lockBluePortal = 0;
    %player.lockOrangePortal = 1;
    if(isObject(%player.getMountedImage(0)) && (%player.getMountedImage(0).getName() $= "pGunPickupImage" || %player.getMountedImage(0).getName() $= "pGunOrangeImage"))
    {
     %player.mountImage(PGunBlueImage,0);
    }
   case 3:
    %player.lockPortalPickup = 0;
    %player.lockBluePortal = 1;
    %player.lockOrangePortal = 1;
    if(isObject(%player.getMountedImage(0)) && (%player.getMountedImage(0).getName() $= "pGunBlueImage" || %player.getMountedImage(0).getName() $= "pGunOrangeImage"))
    {
     %player.mountImage(PGunPickupImage,0);
    }
   case 4:
    %player.lockPortalPickup = 0;
    %player.lockBluePortal = 0;
    %player.lockOrangePortal = 1;
    if(isObject(%player.getMountedImage(0)) && %player.getMountedImage(0).getName() $= "pGunOrangeImage")
    {
     %player.mountImage(PGunBlueImage,0);
    }
  }
 }
}

registerOutputEvent(Player, clearPortals, "", 1);
function Player::clearPortals(%obj, %client)
{
  if(isObject(%obj.portalBlue)){%obj.portalBlue.delete();%play = 1;}
  if(isObject(%obj.portalOrange)){%obj.portalOrange.delete();%play = 1;}
  if(!isObject(%obj) || !%play){return;}
  serverplay3d(pGunCloseSound,%obj.getTransform());
}

registerOutputEvent(fxDTSBrick, clearPortals, "", 1);
function fxDTSBrick::clearPortals(%obj,%client)
{
  if(isObject(%obj.portalBlue)){%obj.portalBlue.delete();%play = 1;}
  if(isObject(%obj.portalOrange)){%obj.portalOrange.delete();%play = 1;}
  if(!isObject(%obj) || !%play){return;}
  serverplay3d(pGunCloseSound,%obj.getTransform());
}

registerOutputEvent(fxDTSBrick, setAntiPortal, "bool", 1);
function fxDTSBrick::setAntiPortal(%obj,%anti, %client)
{
  %obj.antiPortal = %anti;
}

//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

brickSpawnPointData.noPortal = 1;